<?php

function diff_check_shortcode( $atts ) {
    $atts = shortcode_atts( array(
        'text1' => '',
        'text2' => '',
        'file1' => '',
        'file2' => '',
    ), $atts, 'diff_check' );

    if($atts['file1'] != ''){
        $text1 = file_get_contents($atts['file1']);
    }else{
        $text1 = $atts['text1'];
    }

    if($atts['file2'] != ''){
        $text2 = file_get_contents($atts['file2']);
    }else{
        $text2 = $atts['text2'];
    }

    // Convert text to HTML entities
    $text1_entities = htmlentities($text1, ENT_COMPAT | ENT_HTML401, 'UTF-8');
    $text2_entities = htmlentities($text2, ENT_COMPAT | ENT_HTML401, 'UTF-8');

    // Generate the text diff using HTML entities
    $diff = wp_text_diff( $text1_entities, $text2_entities );

    // Replace HTML entities with human-readable Cyrillic characters
    $diff = html_entity_decode($diff, ENT_COMPAT | ENT_HTML401, 'UTF-8');

    // Count the differences
    $differences_count = substr_count($diff,'<ins>') + substr_count($diff,'<del>');

    return '<div class="diff-check">' . $diff . '</div><p>Differences found: '.$differences_count.'</p>';
}

add_shortcode( 'diff_check', 'diff_check_shortcode' );
